// 
//  MAC_MP3: A Low Energy Implementation of an Audio Decoder
//
//  Copyright (C) 2007 McMaster University
// 
//==============================================================================
// 
// This file is part of MAC_MP3
// 
// MAC_MP3 is distributed in the hope that it will be useful for further research,
// but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. MAC_MP3 is free; you can redistribute it
// and/or modify it provided that proper reference is provided to the authors. See
// the documents included in the "doc" folder for further details.
//
//==============================================================================


module clock_gen (
	CLOCK_27MHZ_I,
	CLOCK_50MHZ_I,
	RESETN_I,
	CLOCK_DIV_4_O,
	CLOCK_DIV_16_O,
	CLOCK_DIV_500_O
);

input CLOCK_27MHZ_I;
input CLOCK_50MHZ_I;
input RESETN_I;

output CLOCK_DIV_4_O;
output CLOCK_DIV_16_O;
output CLOCK_DIV_500_O;

reg [4:0] div_16_counter;

always @ (posedge CLOCK_27MHZ_I or negedge RESETN_I) begin
	if (RESETN_I == 1'b0) begin
		div_16_counter <= 5'd0;
	end else begin
		div_16_counter <= div_16_counter + 5'd1;
	end
end

assign CLOCK_DIV_4_O = div_16_counter[1];
assign CLOCK_DIV_16_O = div_16_counter[3];

reg  [10:0] div_500_counter;

assign CLOCK_DIV_500_O = div_500_counter[9];

always @ (posedge CLOCK_50MHZ_I or negedge RESETN_I) begin
	if (RESETN_I == 1'b0) begin
		div_500_counter <= 11'd0;
	end else begin
		div_500_counter <= div_500_counter + 11'd1;
	end
end

endmodule

